package fr.username404.snowygui.forge

import fr.username404.snowygui.Snowy
import fr.username404.snowygui.config.SnowyConfigScreen
import net.minecraftforge.fml.ExtensionPoint
import net.minecraftforge.fml.ModLoadingContext
import net.minecraftforge.fml.common.Mod
import net.minecraftforge.fml.event.lifecycle.FMLClientSetupEvent
import net.minecraftforge.fml.javafmlmod.FMLJavaModLoadingContext
import java.util.function.BiFunction
import java.util.function.Supplier

@Mod("snowygui")
class ForgeInit: Snowy() {
    private fun initSetup(event: FMLClientSetupEvent) = atInit()
    private fun configSetup(event: FMLClientSetupEvent) {
        ModLoadingContext.get().registerExtensionPoint(
            ExtensionPoint.CONFIGGUIFACTORY,
            Supplier {
                return@Supplier BiFunction { mc, screen ->
                    return@BiFunction object : SnowyConfigScreen() {
                        override fun onClose() { mc.setScreen(screen) }
                    }
                }
            }
        )
    }
    init {
        with(FMLJavaModLoadingContext.get().modEventBus) {
            addListener(this@ForgeInit::initSetup)
            addListener(this@ForgeInit::configSetup)
        }
    }
}